#!/usr/bin/perl
use Socket;

$CoCoon_IP      = '192.168.1.77';
$CoCoon_PORT    = 51001;
$CGIMODE        = 1;
#$STYLESHEET     = './CCBrowse_list.xsl';
$STYLESHEET     = './CCBrowse.xsl';
$REQUEST        = './CCBrowse.xml';
$HOSTNAME       = 'unknown';

$request_body  = "";
open(REQUEST, "< $REQUEST") || die "open(REQUEST): $!\n";
$request_body .= $_  while(<REQUEST>);
close(REQUEST);

binmode STDOUT;
print "Content-type: text/xml; charset=utf-8\n\n"  if( $CGIMODE );
print <<"__XML1__";
<?xml version='1.0'?>
<?xml-stylesheet type="text/xsl" href="$STYLESHEET"?>

<items>
__XML1__

$StartingIndex = 0;
do {
	$proto = getprotobyname('tcp');
	$that = sockaddr_in($CoCoon_PORT, inet_aton($CoCoon_IP));
	socket(CoCoon, AF_INET, SOCK_STREAM, $proto) || die "socket(CoCoon): $!\n";
	binmode CoCoon;
	connect(CoCoon, $that) || die "connect(CoCoon): $!\n";
	select(CoCoon); $|=1; select(STDOUT);

	$request_body =~ s/>\d+<\/StartingIndex>/>$StartingIndex<\/StartingIndex>/;
	$content_length = length($request_body);
	$request_header = <<"__REQUEST_HEADER__";
POST /upnp/control/ContentDirectory HTTP/1.0
SOAPAction: "urn:schemas-upnp-org:service:ContentDirectory:1#Browse"
Content-Type: text/xml
Host: $CoCoon_IP:$CoCoon_PORT
Content-Length: $content_length
Pragma: no-cache
X-AV-Client-info: av = 2.0 ; cn = "test" ; mn = "CCBrowse"; mv = "0.0.2" ;
X-AV-Physical-Unit-Info: pa = "$HOSTNAME";
__REQUEST_HEADER__
	$request_header =~ s/\r//g;
	$request_header =~ s/\n/\r\n/g;

	#print STDERR $request_header . "\n";
	print CoCoon $request_header . "\r\n";
	print CoCoon $request_body;

	$content_length = 0;
	$unit_info = "";
	$response_header = "";
	while(<CoCoon>) {
		last  if( /^\r\n$/ );
		$response_header .= $_;
		$content_length = $1  if( /^Content-Length:\s*(\d+)/i );
		$unit_info = $1  if( /^X-AV-Physical-Unit-Info: pa = \"(.*)\"/i );
	}
	#print STDERR $response_header . "\n";
	read(CoCoon, $response_body, $content_length);
	close(CoCoon);

	$NumberReturned = 0;
	$TotalMatches = 0;
	$NumberReturned = $1  if( $response_body =~ /<NumberReturned>(\d+)<\/NumberReturned>/ );
	$TotalMatches = $1    if( $response_body =~ /<TotalMatches>(\d+)<\/TotalMatches>/ );

	$result = "";
	if( $response_body =~ /<Result>([\x00-\xff]*)<\/Result>/ ) {
		$result = $1;
		$result =~ s/\&lt;/\</g;
		$result =~ s/\&gt;/\>/g;
		$result =~ s/\&quot;/\"/g;
		$result =~ s/\&apos;/\'/g;
		$result =~ s/\&amp;/\&/g;
		$result =~ s/<\?xml[\x00-\xff]*\?>//;
	}
	print $result;

	$StartingIndex += $NumberReturned;

	#print STDERR "NumberReturned = $NumberReturned\n";
	#print STDERR "TotalMatches = $TotalMatches\n";
	#print STDERR "StartingIndex = $StartingIndex\n";

} while( $NumberReturned && ($StartingIndex < $TotalMatches)  );

print <<"__XML2__";
<unit_info>$unit_info</unit_info>
<http>
<request_header>$request_header</request_header>
<response_header>$response_header</response_header>
</http>
</items>
__XML2__

exit 0;

